Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -4077,5 +4348,5 @@
 
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,      &
+          CALL pmci_interp_1sto_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,      &
                                       r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,&
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -4084,14 +4355,14 @@
        IF ( humidity )  THEN
 
-          CALL pmci_interp_tril_all ( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo, &
+          CALL pmci_interp_1sto_all ( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo, &
                                       r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
 
           IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
-             CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,   &
+             CALL pmci_interp_1sto_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, kcto,         &
                                          iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
                                          ijkfc_s, 's' ) 
-             CALL pmci_interp_tril_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,   &
+             CALL pmci_interp_1sto_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, kcto,         &
                                          iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
@@ -4100,9 +4371,9 @@
 
           IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
-             CALL pmci_interp_tril_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,   &
+             CALL pmci_interp_1sto_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, kcto,         &
                                          iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
                                          ijkfc_s, 's' )
-             CALL pmci_interp_tril_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,   &
+             CALL pmci_interp_1sto_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, kcto,         &
                                          iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
@@ -4113,5 +4384,5 @@
 
        IF ( passive_scalar )  THEN
-          CALL pmci_interp_tril_all ( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,  &
+          CALL pmci_interp_1sto_all ( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,  &
                                       r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
                                       jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
@@ -4120,5 +4391,5 @@
        IF ( air_chemistry  .AND.  nest_chemistry )  THEN
           DO  n = 1, nspec
-             CALL pmci_interp_tril_all ( chem_species(n)%conc,                 &
+             CALL pmci_interp_1sto_all ( chem_species(n)%conc,                 &
                                          chem_spec_c(:,:,:,n),                 &
                                          ico, jco, kco, r1xo, r2xo, r1yo,      &
@@ -4162,5 +4433,5 @@
 
 
-    SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,    &
+    SUBROUTINE pmci_interp_1sto_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,    &
                                      r1z, r2z, kct, ifl, ifu, jfl, jfu,        &
                                      kfl, kfu, ijkfc, var )
@@ -4173,89 +4444,78 @@
        CHARACTER(LEN=1), INTENT(IN) :: var  !<
 
-       INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic    !<
-       INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !<
-       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
+       INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic    !<
+       INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc    !<
+!AH       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
+       INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc    !<
 
        REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !<
        REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc       !<
-       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r1x   !<
-       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r2x   !<
-       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r1y   !<
-       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r2y   !<
-       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r1z   !<
-       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r2z   !<
+       REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  :: r1x   !<
+       REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  :: r2x   !<
+       REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  :: r1y   !<
+       REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  :: r2y   !<
+       REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) :: r1z   !<
+       REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) :: r2z   !<
 
        INTEGER(iwp) :: kct
-       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!AH       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!AH       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+       INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH
+!       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
 
        INTEGER(iwp) ::  i        !<
-       INTEGER(iwp) ::  ib       !<
-       INTEGER(iwp) ::  ie       !<
-       INTEGER(iwp) ::  ijk      !<
        INTEGER(iwp) ::  j        !<
-       INTEGER(iwp) ::  jb       !<
-       INTEGER(iwp) ::  je       !<
        INTEGER(iwp) ::  k        !<
-       INTEGER(iwp) ::  k_wall   !<
-       INTEGER(iwp) ::  k1       !<
-       INTEGER(iwp) ::  kb       !<
-       INTEGER(iwp) ::  kbc      !<
        INTEGER(iwp) ::  l        !<
+       INTEGER(iwp) ::  lb       !<
+       INTEGER(iwp) ::  le       !<
        INTEGER(iwp) ::  m        !<
+       INTEGER(iwp) ::  mb       !<
+       INTEGER(iwp) ::  me       !<
        INTEGER(iwp) ::  n        !<
        INTEGER(iwp) ::  var_flag !<
 
-       REAL(wp) ::  cellsum    !<
-       REAL(wp) ::  cellsumd   !<
-       REAL(wp) ::  fk         !<
-       REAL(wp) ::  fkj        !<
-       REAL(wp) ::  fkjp       !<
-       REAL(wp) ::  fkp        !<
-       REAL(wp) ::  fkpj       !<
-       REAL(wp) ::  fkpjp      !<
-       REAL(wp) ::  logratio   !<
-       REAL(wp) ::  logzuc1    !<
-       REAL(wp) ::  rcorr      !<
-       REAL(wp) ::  rcorr_ijk  !<       
-       REAL(wp) ::  zuc1       !<
-       REAL(wp) ::  z0_topo    !<  roughness at vertical walls
-
-
-       ib = nxl
-       ie = nxr
-       jb = nys
-       je = nyn
-       kb = 0
+
+       lb = icl
+       le = icr
+       mb = jcs
+       me = jcn
+
        IF ( nesting_mode /= 'vertical' )  THEN
           IF ( bc_dirichlet_l )  THEN
-             ib = nxl - 1
+             lb = icl + 1
 !
 !--          For u, nxl is a ghost node, but not for the other variables
              IF ( var == 'u' )  THEN
-                ib = nxl
+                lb = icl + 2
              ENDIF
           ENDIF
           IF ( bc_dirichlet_s )  THEN
-             jb = nys - 1
+             mb = jcs + 1
 !
 !--          For v, nys is a ghost node, but not for the other variables
              IF ( var == 'v' )  THEN
-                jb = nys
+                mb = jcs + 2
              ENDIF
           ENDIF
           IF ( bc_dirichlet_r )  THEN
-             ie = nxr + 1
+             le = icr - 1
           ENDIF
           IF ( bc_dirichlet_n )  THEN
-             je = nyn + 1
+             me = jcn - 1
           ENDIF
        ENDIF
-
+!
+!--    Is masking needed here, think about it.
        IF ( var == 'u' )  THEN 
           var_flag = 1 
@@ -4266,140 +4526,84 @@
        ELSE
           var_flag = 0
-       ENDIF
-!
-!--    Trilinear interpolation.
-       DO  i = ib, ie
-          DO  j = jb, je
-!
-!--          Determine the vertical index of the first node above the
-!--          topography top at grid point (j,i) in order to not overwrite 
-!--          the bottom BC.
-!             kb = get_topography_top_index_ji( j, i, TRIM ( var ) ) + 1             
-             DO  k = kb, nzt + 1
-                l = ic(i)
-                m = jc(j)
-                n = kc(k)
-                fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
-                fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
-                fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
-                fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
-                fk       = r1y(j) * fkj  + r2y(j) * fkjp
-                fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
-                f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
+       ENDIF       
+
+       f(:,:,:) = 0.0_wp
+
+       IF  ( var == 'u' )  THEN
+
+          DO  l = lb, le
+             DO  m = mb, me
+                DO n = 0, kct 
+
+                   DO  i = ifl(l), ifl(l+1)-1
+                      DO  j = jfl(m), jfu(m)
+                         DO  k = kfl(n), kfu(n)
+                            f(k,j,i) = fc(n,m,l)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                   
+                ENDDO
              ENDDO
           ENDDO
-       ENDDO
-!
-!--    Correct the interpolated values of u and v in near-wall nodes, i.e. in
-!--    the nodes below the coarse-grid nodes with k=1. The corrction is only
-!--    made over horizontal wall surfaces in this phase. For the nest boundary
-!--    conditions, a corresponding correction is made for all vertical walls,
-!--    too.
-       IF ( constant_flux_layer .AND. ( var == 'u' .OR. var == 'v' ) )  THEN
-          z0_topo = roughness_length
-          DO  i = ib, nxr
-             DO  j = jb, nyn
-!
-!--             Determine vertical index of topography top at grid point (j,i)
-                k_wall = get_topography_top_index_ji( j, i, TRIM ( var ) )
-!
-!--             kbc is the first coarse-grid point above the surface
-                kbc = 1
-                DO  WHILE ( cg%zu(kbc) < zu(k_wall) )
-                   kbc = kbc + 1
+
+       ELSE IF  ( var == 'v' )  THEN
+
+          DO  l = lb, le
+             DO  m = mb, me
+                DO n = 0, kct 
+               
+                   DO i = ifl(l), ifu(l)
+                      DO  j = jfl(m), jfl(m+1)-1
+                         DO  k = kfl(n), kfu(n)
+                            f(k,j,i) = fc(n,m,l) 
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
                 ENDDO
-                zuc1 = cg%zu(kbc)
-                k1   = k_wall + 1
-                DO  WHILE ( zu(k1) < zuc1 )
-                   k1 = k1 + 1
-                ENDDO
-                logzuc1 = LOG( ( zu(k1) - zu(k_wall) ) / z0_topo )
-
-                k = k_wall + 1
-                DO  WHILE ( zu(k) < zuc1 )
-                   logratio = ( LOG( ( zu(k) - zu(k_wall) ) / z0_topo ) ) /    &
-                                logzuc1
-                   f(k,j,i) = logratio * f(k1,j,i)
-                   k  = k + 1
-                ENDDO
-                f(k_wall,j,i) = 0.0_wp
              ENDDO
           ENDDO
 
-       ELSEIF ( var == 'w' )  THEN
-
-          DO  i = ib, nxr
-              DO  j = jb, nyn
-!
-!--              Determine vertical index of topography top at grid point (j,i)
-                 k_wall = get_topography_top_index_ji( j, i, 'w' )
-
-                 f(k_wall,j,i) = 0.0_wp
-              ENDDO
-           ENDDO
-
-       ENDIF
-!
-!--    Apply the reversibility correction. 
-       DO  l = icl, icr
-          DO  m = jcs, jcn
-             DO  n = 0, kct+1
-                ijk = 1
-                cellsum   = 0.0_wp
-                cellsumd  = 0.0_wp
-!
-!--             Note that the index name i must not be used here as a loop 
-!--             index name since i is the constant boundary index, hence 
-!--             the name ia. 
-                DO  i = ifl(l), ifu(l)   
-                   DO  j = jfl(m), jfu(m)
-                      DO  k = kfl(n), kfu(n)
-                         cellsum = cellsum + MERGE( f(k,j,i), 0.0_wp,           &
-                              BTEST( wall_flags_0(k,j,i), var_flag ) )
-                         celltmpd(ijk) = ABS( fc(n,m,l) - f(k,j,i) )
-                         cellsumd      = cellsumd  + MERGE( celltmpd(ijk),      &
-                              0.0_wp, BTEST( wall_flags_0(k,j,i), var_flag ) )
-                         ijk = ijk + 1
+       ELSE IF  ( var == 'w' )  THEN
+
+          DO  l = lb, le
+             DO  m = mb, me
+                DO n = 1, kct + 1   ! It is important to go up to kct+1  
+
+                   DO i = ifl(l), ifu(l)
+                      DO  j = jfl(m), jfu(m)
+                         f(nzb,j,i) = 0.0_wp   ! Because the n-loop starts from n=1 instead of 0
+                         DO  k = kfu(n-1)+1, kfu(n) 
+                            f(k,j,i) = fc(n,m,l)
+                         ENDDO
                       ENDDO
                    ENDDO
+                   
                 ENDDO
-                
-                IF ( ijkfc(n,m,l) /= 0 )  THEN
-                   cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
-                   rcorr     = fc(n,m,l) - cellsum
-                   cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
-                ELSE
-                   cellsum   = 0.0_wp                  
-                   rcorr     = 0.0_wp
-                   cellsumd  = 1.0_wp
-                   celltmpd  = 1.0_wp
-                ENDIF
-! 
-!--             Distribute the correction term to the child nodes according to 
-!--             their relative difference to the parent value such that the
-!--             node with the largest difference gets the largest share of the 
-!--             correction. The distribution is skipped if rcorr is negligibly 
-!--             small in order to avoid division by zero. 
-                IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
-                   cellsumd  = 1.0_wp
-                   celltmpd  = 1.0_wp
-                ENDIF
-
-                ijk = 1
-                DO  i = ifl(l), ifu(l)
-                   DO  j = jfl(m), jfu(m)
-                      DO  k = kfl(n), kfu(n)
-                         rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
-                         f(k,j,i) = f(k,j,i) + rcorr_ijk
-                         ijk = ijk + 1
+             ENDDO
+          ENDDO
+
+       ELSE   ! scalars
+
+          DO  l = lb, le
+             DO  m = mb, me
+                DO n = 0, kct 
+                   
+                   DO i = ifl(l), ifu(l)
+                      DO  j = jfl(m), jfu(m)
+                         DO  k = kfl(n), kfu(n)
+                            f(k,j,i) = fc(n,m,l)
+                         ENDDO
                       ENDDO
                    ENDDO
+                   
                 ENDDO
-             
-             ENDDO  ! n
-          ENDDO  ! m
-       ENDDO  ! l
-
-    END SUBROUTINE pmci_interp_tril_all
+             ENDDO
+          ENDDO
+
+       ENDIF  ! var
+
+    END SUBROUTINE pmci_interp_1sto_all
 
 #endif
@@ -4674,13 +4878,21 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), INTENT(IN) ::  direction   !<
+    INTEGER(iwp), INTENT(IN) ::  direction  !< Transfer direction: parent_to_child or child_to_parent
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  icl         !<
-    INTEGER(iwp) ::  icr         !<
-    INTEGER(iwp) ::  jcs         !<
-    INTEGER(iwp) ::  jcn         !<
-    
-    REAL(wp), DIMENSION(1) ::  dtl         !<
+    INTEGER(iwp) ::  icl         !< Parent-grid array index bound, left
+    INTEGER(iwp) ::  icr         !< Parent-grid array index bound, right
+    INTEGER(iwp) ::  jcn         !< Parent-grid array index bound, north
+    INTEGER(iwp) ::  jcs         !< Parent-grid array index bound, south
+    INTEGER(iwp) ::  icla        !< Auxiliary-array (index-mapping etc) index bound, left
+    INTEGER(iwp) ::  icra        !< Auxiliary-array (index-mapping etc) index bound, right
+    INTEGER(iwp) ::  jcna        !< Auxiliary-array (index-mapping etc) index bound, north
+    INTEGER(iwp) ::  jcsa        !< Auxiliary-array (index-mapping etc) index bound, south
+    INTEGER(iwp) ::  iclw        !< Parent-grid work array index bound, left
+    INTEGER(iwp) ::  icrw        !< Parent-grid work array index bound, right
+    INTEGER(iwp) ::  jcnw        !< Parent-grid work array index bound, north
+    INTEGER(iwp) ::  jcsw        !< Parent-grid work array index bound, south
+
+    REAL(wp), DIMENSION(1) ::  dtl         !< Time step size
 
 
@@ -4689,8 +4901,16 @@
 !
 !--    Child domain boundaries in the parent indice space.
-       icl = coarse_bound(1)
-       icr = coarse_bound(2)
-       jcs = coarse_bound(3)
-       jcn = coarse_bound(4)
+       icl  = coarse_bound(1)
+       icr  = coarse_bound(2)
+       jcs  = coarse_bound(3)
+       jcn  = coarse_bound(4)
+       icla = coarse_bound_aux(1)
+       icra = coarse_bound_aux(2)
+       jcsa = coarse_bound_aux(3)
+       jcna = coarse_bound_aux(4)
+       iclw = coarse_bound_w(1)
+       icrw = coarse_bound_w(2)
+       jcsw = coarse_bound_w(3)
+       jcnw = coarse_bound_w(4)
 
        IF ( direction == parent_to_child )  THEN
@@ -4736,10 +4956,9 @@
 !--    horizontal boundaries
        IF ( nesting_mode /= 'vertical' )  THEN
-       
 !
 !--       Left border pe:
           IF ( bc_dirichlet_l )  THEN
 
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+             CALL pmci_interp_1sto_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
                                        r1yo, r2yo, r1zo, r2zo,                  &
                                        logc_u_l, logc_ratio_u_l,                &
@@ -4748,5 +4967,5 @@
                                        kfuo, ijkfc_u, 'l', 'u' )
 
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+             CALL pmci_interp_1sto_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
                                        r1yv, r2yv, r1zo, r2zo,                  &
                                        logc_v_l, logc_ratio_v_l,                &
@@ -4755,5 +4974,5 @@
                                        kfuo, ijkfc_v, 'l', 'v' )
 
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+             CALL pmci_interp_1sto_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
                                        r1yo, r2yo, r1zw, r2zw,                  &
                                        logc_w_l, logc_ratio_w_l,                &
@@ -4765,5 +4984,5 @@
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-!                CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                CALL pmci_interp_1sto_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
 !                                          r1yo, r2yo, r1zo, r2zo,              &
 !                                          logc_w_l, logc_ratio_w_l,            &
@@ -4780,5 +4999,5 @@
 
              IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-                CALL pmci_interp_tril_lr( diss,  dissc,  ico, jco, kco, r1xo,  &
+                CALL pmci_interp_1sto_lr( diss,  dissc,  ico, jco, kco, r1xo,  &
                                           r2xo, r1yo, r2yo, r1zo, r2zo,        &
                                           logc_w_l, logc_ratio_w_l,            &
@@ -4789,5 +5008,5 @@
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
+                CALL pmci_interp_1sto_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_l, logc_ratio_w_l,            &
@@ -4799,5 +5018,5 @@
              IF ( humidity )  THEN
 
-                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
+                CALL pmci_interp_1sto_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_l, logc_ratio_w_l,            &
@@ -4807,5 +5026,5 @@
 
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
-                   CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( qc, qcc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_l, logc_ratio_w_l,         &
@@ -4815,5 +5034,5 @@
                                              kflo, kfuo, ijkfc_s, 'l', 's' )  
 
-                   CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( nc, ncc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_l, logc_ratio_w_l,         &
@@ -4825,5 +5044,5 @@
 
                 IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
-                   CALL pmci_interp_tril_lr( qr, qrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_l, logc_ratio_w_l,         &
@@ -4833,5 +5052,5 @@
                                              kflo, kfuo, ijkfc_s, 'l', 's' ) 
 
-                   CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_l, logc_ratio_w_l,         &
@@ -4845,5 +5064,5 @@
 
              IF ( passive_scalar )  THEN
-                CALL pmci_interp_tril_lr( s, sc, ico, jco, kco, r1xo, r2xo,    &
+                CALL pmci_interp_1sto_lr( s, sc, ico, jco, kco, r1xo, r2xo,    &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_l, logc_ratio_w_l,            &
@@ -4856,5 +5075,5 @@
              IF ( air_chemistry  .AND.  nest_chemistry )  THEN
                 DO  n = 1, nspec
-                   CALL pmci_interp_tril_lr( chem_species(n)%conc,             &
+                   CALL pmci_interp_1sto_lr( chem_species(n)%conc,             &
                                              chem_spec_c(:,:,:,n),             &
                                              ico, jco, kco, r1xo, r2xo,        &
@@ -4873,5 +5092,5 @@
           IF ( bc_dirichlet_r )  THEN
              
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
+             CALL pmci_interp_1sto_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
                                        r1yo, r2yo, r1zo, r2zo,                 &
                                        logc_u_r, logc_ratio_u_r,               &
@@ -4880,5 +5099,5 @@
                                        kfuo, ijkfc_u, 'r', 'u' )
 
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
+             CALL pmci_interp_1sto_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
                                        r1yv, r2yv, r1zo, r2zo,                 &
                                        logc_v_r, logc_ratio_v_r,               &
@@ -4887,5 +5106,5 @@
                                        kfuo, ijkfc_v, 'r', 'v' )
 
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
+             CALL pmci_interp_1sto_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
                                        r1yo, r2yo, r1zw, r2zw,                 &
                                        logc_w_r, logc_ratio_w_r,               &
@@ -4897,5 +5116,5 @@
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-!                CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                CALL pmci_interp_1sto_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
 !                                          r1yo,r2yo, r1zo, r2zo,               &
 !                                          logc_w_r, logc_ratio_w_r,            &
@@ -4911,5 +5130,5 @@
 
              IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-                CALL pmci_interp_tril_lr( diss,  dissc,  ico, jco, kco, r1xo,  &
+                CALL pmci_interp_1sto_lr( diss,  dissc,  ico, jco, kco, r1xo,  &
                                           r2xo, r1yo,r2yo, r1zo, r2zo,         &
                                           logc_w_r, logc_ratio_w_r,            &
@@ -4921,5 +5140,5 @@
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
+                CALL pmci_interp_1sto_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_r, logc_ratio_w_r,            &
@@ -4930,5 +5149,5 @@
 
              IF ( humidity )  THEN
-                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
+                CALL pmci_interp_1sto_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_r, logc_ratio_w_r,            &
@@ -4939,5 +5158,5 @@
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
 
-                   CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( qc, qcc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_r, logc_ratio_w_r,         &
@@ -4947,5 +5166,5 @@
                                              kflo, kfuo, ijkfc_s, 'r', 's' ) 
      
-                   CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( nc, ncc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_r, logc_ratio_w_r,         &
@@ -4960,5 +5179,5 @@
 
      
-                   CALL pmci_interp_tril_lr( qr, qrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( qr, qrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_r, logc_ratio_w_r,         &
@@ -4969,5 +5188,5 @@
                                              'r', 's' ) 
 
-                   CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo,     &
+                   CALL pmci_interp_1sto_lr( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_r, logc_ratio_w_r,         &
@@ -4982,5 +5201,5 @@
 
              IF ( passive_scalar )  THEN
-                CALL pmci_interp_tril_lr( s, sc, ico, jco, kco, r1xo, r2xo,    &
+                CALL pmci_interp_1sto_lr( s, sc, ico, jco, kco, r1xo, r2xo,    &
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_r, logc_ratio_w_r,            &
@@ -4993,5 +5212,5 @@
              IF ( air_chemistry  .AND.  nest_chemistry )  THEN
                 DO  n = 1, nspec
-                   CALL pmci_interp_tril_lr( chem_species(n)%conc,             &
+                   CALL pmci_interp_1sto_lr( chem_species(n)%conc,             &
                                              chem_spec_c(:,:,:,n),             &
                                              ico, jco, kco, r1xo, r2xo,        &
